/*
 Faa um programa que leia informaes sobre n
pessoas. Essa informao deve ficar em um vetor de
variveis do tipo estruturado pessoa, o qual deve conter
as seguintes informaes:

    Nome: string de tamanho 30;
    Sexo: caractere 'f' ou 'm';
    Idade: valor inteiro;
    Estado Civil: 's' para solteiro, 'c' para casado, 'v' para vivo,
                   'o' para outros.
    Salrio: valor real.

Em seguida, imprima o nmero de homens, nmero de
mulheres e informaes da pessoa com maior salrio.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef struct pes pessoa;
struct pes {
    char nome[30];
    char sexo;
    int idade;
    char estadoCivil;
    float salario;
};

void leDadosDePessoas(int n, pessoa P[]) //recebe cpia do valor de n e endereo de P da main
{                                        //para n e P na leDadosDePessoas
    int i;

    for (i = 0; i < n; i++) {
         printf("\nentre nome: ");
         fflush(stdin); //limpar buffer do teclado - limpar arquivo de entrada de dados
         gets(P[i].nome);
         printf("entre sexo (m: Masc, f: Fem): ");
         fflush(stdin);
         scanf("%c", &P[i].sexo);
         printf("entre idade: ");
         scanf("%d", &P[i].idade);
         printf("entre estado civil (s: solteiro, c: casado,o: outros, v: viuvo): ");
         fflush(stdin);
         scanf("%c", &P[i].estadoCivil);
         printf("entre salario: ");
         scanf("%f", &P[i].salario);
    }
}

int contHomens(int n, pessoa P[]) //recebe cpia do valor de n e endereos de P da main
{
    int i, nH;

    nH =0;
    for (i = 0; i < n; i++) {
        if (P[i].sexo == 'm') nH++;
    }

    return nH;
}

int contMulheres(int n, pessoa P[]) //recebe cpia do valor de n e endereos de P da main
{
    int i, nM;

    nM = 0;
    for (i = 0; i < n; i++) {
        if (P[i].sexo == 'f') nM++;
    }

    return nM;
}

pessoa pesssoaMaiorSalario(int n, pessoa P[]) //recebe cpia do valor de n e endereo de P da main
{
    int i;
    pessoa maisRica;
    float maiorSal = 0;

    for (i = 0; i < n; i++) {
        if (P[i].salario > maiorSal) {
           maiorSal = P[i].salario;
 //          maisRica = P[i]; //atribuio de varivel do tipo struct para struct
           strcpy(maisRica.nome,P[i].nome); //atribuio de varivel do tipo string para string
           maisRica.sexo = P[i].sexo;
           maisRica.idade = P[i].idade;
           maisRica.estadoCivil = P[i].estadoCivil;
           maisRica.salario = P[i].salario;
        }
    }

    return maisRica; //retorna uma struct - todos os dados da pessoa de maior salrio
}

int main()
{
    pessoa P[15], maisRica;
    int n, i, nH, nM;

    printf("entre numero efetivo de pessoas: ");
    scanf("%d", &n);
    leDadosDePessoas( n, P);//envia cpia do valor de n e endereo de P da main  para n e P na leDadosDePessoas
    nH = contHomens( n, P);//envia cpia do valor de n e endereos de P da main  para n e P na contHomens
    nM = contMulheres( n, P);//envia cpia do valor de n e endereos de P da main  para n e P na contMulheres
    maisRica = pesssoaMaiorSalario( n, P);

    printf("\n\nNumero de homens: %d", nH);
    printf("\n\nNumero de mulheres: %d", nM);
    printf("\n\nPessoa mais rica: \n\tNome: %s", maisRica.nome);
    printf("\n\tSalario: %8.2f", maisRica.salario);
    printf("\n\tSexo: %c",maisRica.sexo);
    printf("\n\tIdade: %d", maisRica.idade);
    printf("\n\tEstado civil: %c\n",maisRica.estadoCivil);

    return 0;
}
