/*
1. Defina uma estrutura para armazenar pontos do R2.
2. Defina uma funo que receba dois pontos, por valor, e retorne
   um ponto em que as coordenadas sejam a soma das coordenadas
   passadas como parmetro.
3. Defina uma funo que receba por parametro, um ponto, e altere
   suas coordenadas para que distem de apenas uma unidade da origem
   do r2, isto , assuma que o ponto indica um vetor saindo da
   origem e normalize-o. O comprimento de um vetor  igual  raiz
   quadrada da soma dos quadrados de suas componentes, e o vetor
   pode ser normalizado dividindo-se cada uma de suas componentes
   pelo comprimento do vetor.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

typedef struct pto ponto;
struct pto {
    float x;
    float y;
};

ponto soma(ponto a, ponto b)
{
    ponto c;

    c.x = a.x + b.x;
    c.y = a.y + b.y;

    return c;
}

ponto normalizaPonto(ponto p)
{
    float aux;

    aux = sqrt( (p.x)*(p.x) + (p.y)*(p.y) );
    p.x = p.x/aux;
    p.y = p.y/aux;

    return p;
}

int main()
{
    ponto a, b, c;
    int i;

    a.x = 1;
    a.y = 1;
    b.x = 2;
    b.y = 2;

    printf("\nPonto a: ");
    printf("x = %f  y = %f\n", a.x, a.y);
    printf("\nPonto b: ");
    printf("x = %f  y = %f\n", b.x, b.y);

    printf("\nsomaPonto a e b:  ");
    c = soma(a, b);
    printf("x = %f  y = %f\n", c.x, c.y);

    a = normalizaPonto(a);
    printf("\nnormalizaPonto a:  ");
    printf("x = %f  y = %f\n", a.x, a.y);

    b = normalizaPonto(b);
    printf("\nnormalizaPonto b:  ");
    printf("x = %f  y = %f\n", b.x, b.y);

    return 0;
}
