#include <stdlib.h>
#include <stdio.h>

#define T 50


typedef
struct{
  char nuMatric[12];
  char nome[41];
  char sx;
  int tw;
  int p1;
  int p2;
  int p3;
  int notF;
  int numF;
}aluno;

int menu()
{
    int op;

    printf("\n=======================================================\n"
           " 1 Digitar dados dos alunos.\n"
           " 2 Calcular nota final dos alunos.\n"
           " 3 Calcular nota media da turma.\n"
           " 4 Calcular quantas alunas foram aprovadas.\n"
           " 5 Calcular porcentagen alunos acima da nota media.\n"
           " 6 Classificar por nota final.\n"
           " 7 Gerar Boletim.\n"
           " 8 Sair do programa.\n"
           "\n Qual sua opcao?: ");
    scanf("%d", &op);

    return op;
}

void lerDados(aluno x[], int n)
{
    int i;

    printf("\nEntre com os dados dos %d alunos :", n);
    for(i =0 ; i <n; i++)
    {
        printf("\naluno %d", i+1);
        printf("\nNum. Matricula: ");
        fflush(stdin);
        scanf("%s", &x[i].nuMatric);
        printf("          Nome: ");
        fflush(stdin);
        gets(x[i].nome);
        printf("    Sexo (f/m): ");
        fflush(stdin);
        scanf("%c", &x[i].sx);
        printf(" Nota trabalho: ");
        scanf("%d", &x[i].tw);
        printf("   Nota prova1: ");
        scanf("%d", &x[i].p1);
        printf("   Nota prova2: ");
        scanf("%d", &x[i].p2);
        printf("   Nota prova3: ");
        scanf("%d", &x[i].p3);
        printf("   Num. faltas: ");
        scanf("%d", &x[i].numF);
    }
}

void calculaNotaFinal(aluno x[], int n)
{
    int i;

    for(i =0 ; i <n; i++)
    {
        x[i].notF = x[i].tw + x[i].p1 + x[i].p2 + x[i].p3;
    }
}

float calcula_Media(aluno x[], int n)
{
    int i;

    float soma =0;
    for(i =0 ; i <n; i++)
    {
        soma = soma + x[i].notF;
    }
    return soma/n;
}

int contAprovadosFem(aluno x[], int n)
{
    int i;

    int res =0;
    for(i =0; i <n; i++)
    {
        if(x[i].sx =='f' && x[i].notF>=60 && x[i].numF<18)
        {
            res++;
        }
    }
    return res;
}

float porcentagemAcimaMedia(aluno x[], float ma, int n)
{
    int i;

    int res =0;
    for(i =0; i <n; i++)
    {
        if(x[i].notF>ma)
        {
            res++;
        }
    }
    return 100.0*res/n;
}

void bubbleSort(aluno x[], int n)
{
    int i, j;
    aluno aux;

    for(i = n-1; i > 0; i--) {
        for(j = 0; j < i; j++) {
            if(x[j].notF > x[j+1].notF)//troca
            {
                aux = x[j];
                x[j] = x[j+1];
                x[j+1] = aux;
            }
        }
    }
}

void boletim(aluno x[], int n)
{
    int i;

    printf("\n Relatorio de aproveitamento dos alunos :\n");
    for(i =0 ; i <n; i++)
    {
        printf("\n aluno %d", i+1);
        printf("\n Num. Matricula: %s", x[i].nuMatric);
        printf("\n           Nome: %s", x[i].nome);
        printf("\n     nota Final: %d", x[i].notF);
        printf("\n    num. Faltas: %d", x[i].numF);
        printf("\n");
    }

}

int main()
{
    aluno x[T];
    int n, opcao, contAprovFem;
    float notaMedia, porcentagem;

    do{
        opcao = menu();
        switch(opcao)
        {
            case 1:
                printf("\nEntre com o numero de alunos, n <%d: ", T);
                scanf("%d", &n);
                lerDados(x, n);
                break;
            case 2:
                calculaNotaFinal(x, n);
                break;
            case 3:
                notaMedia = calcula_Media(x, n);
                printf("\n Nota media da turma: %f\n", notaMedia);
                break;
            case 4:
                contAprovFem = contAprovadosFem(x, n);
                printf("\n Numero de alunas aprovadas: %d\n", contAprovFem);
                break;
            case 5:
                porcentagem = porcentagemAcimaMedia(x, notaMedia, n);
                printf("\n Porcentagen alunos acima da nota media: %f\n", porcentagem);
                break;
            case 6:
                bubbleSort(x, n);
                break;
            case 7:
                boletim(x, n);
                break;
            default:
                if(opcao!=8)
                     printf("\nOpcao invalida. \n");
        }//fim switch
        /*O programa s termina quando o usurio digitar 8, pois a condio para que
        o lao do-while continue  que a opo digitada pelo usurio seja diferente de 8.
        Enquanto isso no ocorrer, o menu de opes continuar sendo mostrado na tela.*/
    }while (opcao != 8);

    return 0;
}
